/*
Colorpass Effect
0001
photropik@yahoo.co.uk

Adapted from GrayAndRed.fx by http://www.outerspace-software.com/

*/

// --------------------------------------------------------------------------------------------------
// PARAMETERS:
// --------------------------------------------------------------------------------------------------

//Transforms
float4x4 tWVP : WorldViewProjection;

//Colors
float4 Prop0 : COLOR  = {1.0, 0.0, 0.0, 1.0};
float4 Prop1 : COLOR  = {0.0, 1.0, 0.7, 1.0};

float amount;

//texture
texture Tex <string uiname="Texture";>;
sampler Samp = sampler_state    //sampler for doing the texture-lookup
{
    Texture   = (Tex);          //apply a texture to the sampler
    MipFilter = LINEAR;         //sampler states
    MinFilter = LINEAR;
    MagFilter = LINEAR;
};

float4x4 tTex: TEXTUREMATRIX <string uiname="Texture Transform";>;

//the data structure: "vertexshader to pixelshader"
//used as output data with the VS function
//and as input data with the PS function
struct vs2ps
{
    float4 Pos  : POSITION;
    float2 TexCd : TEXCOORD0;
};

// --------------------------------------------------------------------------------------------------
// VERTEXSHADERS
// --------------------------------------------------------------------------------------------------

vs2ps VS(
    float4 PosO  : POSITION,
    float4 TexCd : TEXCOORD0
    )
{
    //inititalize all fields of output struct with 0
    vs2ps Out = (vs2ps)0;

    //transform position
    Out.Pos = mul(PosO, tWVP);

    //transform texturecoordinates
    Out.TexCd = mul(TexCd, tTex);

    return Out;
}

// -------------------------------------------------------------------------------------------------------------------------------------
// PIXELSHADERS:
// -------------------------------------------------------------------------------------------------------------------------------------




float4 PS_Colorpass(vs2ps In): COLOR

{
    float4 c = tex2D(Samp, In.TexCd);

    float g = (c.x+c.y+c.z)*0.333;
    float4 Grijs = float4(g,g,g,c.w);

	float d=0;
	d += (c.x-Prop0.x) * (c.x-Prop0.x);
	d += (c.y-Prop0.y) * (c.y-Prop0.y);
	d += (c.z-Prop0.z) * (c.z-Prop0.z);

	float f=0;
	if(d>Prop1.x)  f=1;
	if(d<=Prop1.x) f=d/=Prop1.x;

       float4 output = tex2D(Samp, In.TexCd);
       output = Prop0 + f*(Grijs - Prop0);
       output.w *= Prop1.w;
       return output;

}









// --------------------------------------------------------------------------------------------------
// TECHNIQUES:
// --------------------------------------------------------------------------------------------------

technique Colorpass
{
    pass p0
    {
        VertexShader = compile vs_1_0 VS();
        PixelShader = compile ps_2_0 PS_Colorpass();
    }

}

//EOF//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
